
#include <stdio.h>
#include "plugin1.h"

#include <QtDesigner/QExtensionFactory>

extern "C" AbstractPlugin *create() {
    return new Plugin1(0);
}

extern "C" void destroy(AbstractPlugin *plugin) {
    delete plugin;
}

Plugin1::Plugin1(QObject *parent)
 : AbstractPlugin(parent)
{
}


void Plugin1::mySig(){}

Plugin1::~Plugin1()
{
}

QString Plugin1::foo(QString arg1, Struct1 s1)
{
    arg1 += "Plugin1::foo(): ";
    arg1.append(QString("%1 ").arg(s1.a));
    arg1.append(QString("%1 ").arg(s1.b));
    return arg1;
}

class Plugin1ExtensionFactoryV1: public QExtensionFactory {
public:
    Plugin1ExtensionFactoryV1(QExtensionManager *parent = 0)
        :QExtensionFactory(parent)
    {
    }

protected:
    virtual QObject *createExtension(QObject *object, const QString &iid, QObject *parent) const
    {
//         printf("1\n");
        if (iid != Q_TYPEID(Plugin1IfaceV1))
            return 0;
//         printf("2\n");
        return qobject_cast<Plugin1*>(object);
    }

};

class Plugin1ExtensionFactoryV2: public QExtensionFactory {
public:
    Plugin1ExtensionFactoryV2(QExtensionManager *parent = 0)
        :QExtensionFactory(parent)
    {
    }

protected:
    virtual QObject *createExtension(QObject *object, const QString &iid, QObject *parent) const
    {
//         printf("1\n");
        if (iid != Q_TYPEID(Plugin1IfaceV2))
            return 0;
//         printf("2\n");
        return qobject_cast<Plugin1*>(object);
    }

};

void Plugin1::setExtensionManager(QExtensionManager *manager)
{
    AbstractPlugin::setExtensionManager(manager);
    printf("s1\n");
    m_manager->registerExtensions(new Plugin1ExtensionFactoryV1(m_manager),
        Q_TYPEID(Plugin1IfaceV1));
    m_manager->registerExtensions(new Plugin1ExtensionFactoryV2(m_manager),
        Q_TYPEID(Plugin1IfaceV2));
    printf("s2\n");
}
