#include "plugin2.h"

#include <QMetaObject>
#include <QGenericArgument>

#include "iface/plugin1iface.h"

extern "C" {
    AbstractPlugin *create() {
        return new Plugin2(0);
    }

    void destroy(AbstractPlugin *plugin) {
        delete plugin;
    }
}

Plugin2::Plugin2(QObject *parent)
 : AbstractPlugin(parent)
{
}


Plugin2::~Plugin2()
{
}

void Plugin2::say(QString arg)
{
    qWarning("%s", arg.toLatin1().constData());
}

void Plugin2::process(AbstractPlugin *other)
{
    say("Plugin2::process()...");

    //BC-way #1
    Plugin1IfaceV1 *v1 = qt_extension<Plugin1IfaceV1*>(m_manager, other);
    if (v1) {
        v1->doSmth();
    }
    Plugin1IfaceV2 *v2 = qt_extension<Plugin1IfaceV2*>(m_manager, other);
    if (v2) {
	connect(other, SIGNAL(mySig()), this, SLOT(myslot()));
        v2->doSmth();
        say(v2->foo("BC: ", Struct1(1, 2.3)));
    }

}

void Plugin2::myslot()
{
	say("HELLO");

    //BC-way #2
/*    Plugin1 plugin1(other);
    say(plugin1.foo("BC: ", Struct1(1, 2.3)));
    plugin1.doSmth();*/

    //BIC-way
/*    Plugin1 *plugin1 = dynamic_cast<Plugin1*>(other);
    if (plugin1) {
        say(plugin1->foo("BIC: "));
        plugin1->doSmth();
    }*/
}

