
#include <stdio.h>
#include "plugin3.h"

#include <QtDesigner/QExtensionFactory>

extern "C" AbstractPlugin *create() {
    return new Plugin3(0);
}

extern "C" void destroy(AbstractPlugin *plugin) {
    delete plugin;
}

Plugin3::Plugin3(QObject *parent)
 : AbstractPlugin(parent)
{
}


Plugin3::~Plugin3()
{
}

QString Plugin3::foo(QString arg1, Struct1 s1)
{
    arg1 += "Plugin3::foo(): ";
    arg1.append(QString("%1 ").arg(s1.a));
    arg1.append(QString("%1 ").arg(s1.b));
    emit mySig();
    return arg1;
}

class Plugin3ExtensionFactoryV1: public QExtensionFactory {
public:
    Plugin3ExtensionFactoryV1(QExtensionManager *parent = 0)
        :QExtensionFactory(parent)
    {
    }

protected:
    virtual QObject *createExtension(QObject *object, const QString &iid, QObject *parent) const
    {
//         printf("1\n");
        if (iid != Q_TYPEID(Plugin1IfaceV1))
            return 0;
//         printf("2\n");
        return qobject_cast<Plugin3*>(object);
    }

};

class Plugin3ExtensionFactoryV2: public QExtensionFactory {
public:
    Plugin3ExtensionFactoryV2(QExtensionManager *parent = 0)
        :QExtensionFactory(parent)
    {
    }

protected:
    virtual QObject *createExtension(QObject *object, const QString &iid, QObject *parent) const
    {
//         printf("1\n");
        if (iid != Q_TYPEID(Plugin1IfaceV2))
            return 0;
//         printf("2\n");
        return qobject_cast<Plugin3*>(object);
    }

};

void Plugin3::setExtensionManager(QExtensionManager *manager)
{
    AbstractPlugin::setExtensionManager(manager);
    printf("s1\n");
    m_manager->registerExtensions(new Plugin3ExtensionFactoryV1(m_manager),
        Q_TYPEID(Plugin1IfaceV1));
    m_manager->registerExtensions(new Plugin3ExtensionFactoryV2(m_manager),
        Q_TYPEID(Plugin1IfaceV2));
    printf("s2\n");
}
